# Update Contacts

> Source: https://truto.one/docs/api-reference/unified-marketing-automation-api/contacts/update/

`PATCH /unified/marketing-automation/contacts/{id}`

Resource: **Contacts** · API: **Unified Marketing Automation API**

## Supported integrations

Constant Contact, GetResponse, Mailchimp

## Path parameters

- **`id`** _(string, required)_
  The ID of the resource.

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`list_id`** _(unknown)_

## Request body

- **`email`** _(string)_
  The contact's email
- **`first_name`** _(string)_
  The contact's first name
- **`last_name`** _(string)_
  The contact's last name
- **`phones`** _(array<object>)_
  The contact's phone numbers
  - **`phone`** _(string)_
    The phone number
  - **`type`** _(string)_
    The phone number type
- **`addresses`** _(array<object>)_
  The contact's addresses
  - **`street_1`** _(string)_
    The contact's first line of street address
  - **`street_2`** _(string)_
    The contact's second line of street address
  - **`city`** _(string)_
    The contact's city
  - **`state`** _(string)_
    The contact's state
  - **`country`** _(string)_
    The contact's country
  - **`postal_code`** _(string)_
    The contact's postal code
  - **`type`** _(string)_
    The address type
- **`lists`** _(array<object>)_
  The lists that the contact is subscribed to
  - **`id`** _(string)_
    The list's unique identifier
- **`tags`** _(array<object>)_
  The contact's tags
  - **`id`** _(string)_
    The tag's unique identifier
  - **`name`** _(string)_
    The tag's name
- **`update_source`** _(string)_
  The source for the update
  Allowed: `Account`, `Contact`
- **`campaign`** _(object)_
  - **`id`** _(string)_
- **`status`** _(string)_
  The contact's subscription status
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The contact's unique identifier
- **`first_name`** _(string)_
  The contact's first name
- **`last_name`** _(string)_
  The contact's last name
- **`name`** _(string)_
  The contact's full name
- **`email`** _(string)_
  The contact's email
- **`phones`** _(array<object>)_
  The contact's phone numbers
  - **`phone`** _(string)_
    The phone number
  - **`type`** _(string)_
    The phone number type
- **`addresses`** _(array<object>)_
  The contact's addresses
  - **`street_1`** _(string)_
    The contact's first line of street address
  - **`street_2`** _(string)_
    The contact's second line of street address
  - **`city`** _(string)_
    The contact's city
  - **`state`** _(string)_
    The contact's state
  - **`country`** _(string)_
    The contact's country
  - **`postal_code`** _(string)_
    The contact's postal code
  - **`type`** _(string)_
    The address type
- **`lists`** _(array<object>)_
  The lists that the contact is subscribed to
  - **`id`** _(string)_
    The list's unique identifier
- **`tags`** _(array<object>)_
  The contact's tags
  - **`id`** _(string)_
    The tag's unique identifier
  - **`name`** _(string)_
    The tag's name
- **`status`** _(string)_
  The contact's subscription status
- **`updated_at`** _(string)_
  The date and time of the contact's last update
- **`created_at`** _(string)_
  The date and time of the contact's creation
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X PATCH 'https://api.truto.one/unified/marketing-automation/contacts/{id}?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "email": "your_email",
  "first_name": "your_first_name",
  "last_name": "your_last_name",
  "phones": [],
  "addresses": [],
  "lists": [],
  "tags": [],
  "update_source": "Account",
  "campaign": {},
  "status": "your_status",
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "email": "your_email",
  "first_name": "your_first_name",
  "last_name": "your_last_name",
  "phones": [],
  "addresses": [],
  "lists": [],
  "tags": [],
  "update_source": "Account",
  "campaign": {},
  "status": "your_status",
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/marketing-automation/contacts/{id}?integrated_account_id=${integratedAccountId}`, {
  method: 'PATCH',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/marketing-automation/contacts/{id}"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "email": "your_email",
    "first_name": "your_first_name",
    "last_name": "your_last_name",
    "phones": [],
    "addresses": [],
    "lists": [],
    "tags": [],
    "update_source": "Account",
    "campaign": {},
    "status": "your_status",
    "remote_data": {}
}

response = requests.patch(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.update(
  'marketing-automation',
  'contacts',
  '<resource_id>',
  {
  "email": "your_email",
  "first_name": "your_first_name",
  "last_name": "your_last_name",
  "phones": [],
  "addresses": [],
  "lists": [],
  "tags": [],
  "update_source": "Account",
  "campaign": {},
  "status": "your_status",
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.update(
        "marketing-automation",
        "contacts",
        "<resource_id>",
        {
        "email": "your_email",
        "first_name": "your_first_name",
        "last_name": "your_last_name",
        "phones": [],
        "addresses": [],
        "lists": [],
        "tags": [],
        "update_source": "Account",
        "campaign": {},
        "status": "your_status",
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
